% Animation of Time Evolution of Solution to the Heat Equation for Problem 4.1:18 (p.333)
% David Bloore, August 10, 2011

tend=1.5;
i=1000;
dt=tend/i;
n=150;
x=10000;

X=linspace(-pi,pi,x);
U=zeros(1,x);

p=plot(X,U);
title('Truncated Fourier Sine Series and Time Evolution for Heat Equation');
xlabel('0 \leq x \leq \pi');
ylabel('Temperature');
grid on;
xlim([-pi pi]);
ylim([-1 3]);
set(gcf,'Position',[0 356 1440 900]);

for t=0:dt:tend
    U=(1/(2*pi))*ones(1,x);
    for nn=1:2:n
        for xx=1:x
            U(xx)=U(xx)+(1/pi)*exp(-(nn^2)*t)*cos(nn*X(xx));
        end
    end
    set(p,'YData',U);
    drawnow;
end