% Solves Poisson Equation via K2D for f=1, u(unit square)=0 -- Generates Surface Plot
% David Bloore, August 2011

clc;
clear all;


% input for N includes a test to ensure it is an odd integer

boolean=0;

while boolean<1;
    n=input('N?');
    nn=floor(n);
    if nn>1;
        if nn==n;
            nnn=nn^2/2;
            nnnn=floor(nnn);
            if nnnn<nnn
                boolean=1;
            else
                clc;
                display('Please enter an odd integer');
            end
        else
            clc;
            display('Please enter an odd integer');
        end
    else
        clc;
        display('Please enter an odd integer');
    end
end


% global scalar variables constructed from n

deltanode=(n^2+1)/2;
h=1/(n+1);

% construction of K

I=sparse(eye(n));
K=sparse(2*I-diag(ones(1,n-1),1)-diag(ones(1,n-1),-1));

% construction of K2D

K2D=kron(I,K)+kron(K,I);

F=h^2*ones(n^2,1);

% solution of system

u=K2D\F;

% construction of matrices for the plot

Z=sparse(zeros(n));

counter1=1;
while counter1<n^2+1;
    Z(counter1)=u(counter1);
    counter1=counter1+1;
end

X=linspace(h,1-h,n);
Y=linspace(h,1-h,n);

% the plot

surf=surf(X,Y,Z);
view(-30,65);
title(sprintf('Solution of Poisson Equation via K2D with f=1 Using %d Equally Spaced Meshpoints per Axis',n));
xlabel('0 \leq x \leq 1');
ylabel('0 \leq y \leq 1');
zlabel('z');
xlim([0 1]);
ylim([0 1]);
set(surf,'EdgeColor','none');