% Travelling Wave Animation for Two Superimposed Travelling Waves of Oscillatory Translation
% David Bloore, August 2011

% domain, bounds and interval -- adjusts as a funcion of k

x0=-3*pi;
xn=3*pi;
d=floor(5000*(1/pi)*(xn-x0));
nti=1500;

x=linspace(x0,xn,d);

% construction of matrices for dynamic wave coefficients

K1=linspace(0,20,nti);
O1=2*sin(linspace(0,64*pi,nti));
K2=linspace(20,0,nti);
O2=-sin(linspace(0,64*pi,nti));

% initial y-values for plot

y=sin(K1(1)*x)+sin(K2(1)*x);

% plot and parameters

p=plot(x,y);
grid on;
title('Travelling Wave Animation for Two Superimposed Travelling Waves of Oscillatory Translation');
xlabel('x');
ylabel('sin(k1*x-o1*t)+sin(k2*x-o2*t)');
xlim([x0 xn]);
ylim([-2.05 2.05]);
set(gcf,'Position',[0 356 1440 900]);

% animation loop

for fr=2:nti;
    y=sin(K1(fr)*x-O1(fr))+sin(K2(fr)*x-O2(fr));
    set(p,'YData',y);
    drawnow;
end